/**
 * This file contains various "statics" used by both the IDEs
 * and the generated applications. They were moved here to enable
 * creating widgets that use them and are included in our custom
 * dojo build.
 */

dojo.provide("zero.form.common.components.statics");

DEFAULT_HINT_VALUE = "(e.g., hint)";
ZERO_FORM_DND_ELEMENT="zero-form-dnd-element";

BOOLEAN_VALUE = "booleanValue";

LENGTH_PROPERTY_SHORT = "short";
LENGTH_PROPERTY_MEDIUM = "medium";
LENGTH_PROPERTY_LONG = "long";
LENGTH_PROPERTY = "LengthPropertyKey";

TYPE_PROPERTY_INTEGER = "integer";
TYPE_PROPERTY_DECIMAL = "decimal";
NUMER_TYPE_PROPERTY = "NumberTypePropertyKey";

NUMBER_INPUT_PROPERTY = "NumberInputPropertyKey";

COUNTRIES_LIST = "countries.js";
US_STATES_LIST = "usStates.js";
MONTHS_LIST = "months.js";
SERVICE_URL = "_url_";
SINGLE_SELECTION_DEFAULT_VALUE = "defaults";

//PREDEFINED_LIST = "predefinedList";

RANGE_PROPERTY_MAX = "max";
RANGE_PROPERTY_MIN = "min";
UNBOUNDED_LABEL = "Unbounded";


DBLCLICK_LIMIT = 300;

_ON_SHOW_DESCRIPTION = 'This event is invoked after the field is presented (either with the entire form or just this field)';
_ON_HIDE_DESCRIPTION  = 'This event is invoked after the field is hidden (either with the entire form or just this field)';
_ON_CLICK_DESCRIPTION = 'This event is invoked whenever the user clicks on the field';
_ON_MOUSE_OVER_DESCRIPTION =  'This event is invoked whenever the pointer is over the field';
_ON_MOUSE_OUT_DESCRIPTION = "This event is invoked whenever the pointer leaves the field's area";
_ON_CHANGE_DESCRIPTION = 'This event is invoked when the value of the field gets changed, either programmatically (e.g, after loading) or manually by the user';

BASE_CLIENT_SIDE_FIELD_EVENTS = {
					onClick: _ON_CLICK_DESCRIPTION,
					onMouseOver: _ON_MOUSE_OVER_DESCRIPTION,
					onMouseOut:_ON_MOUSE_OUT_DESCRIPTION,
					onChange: _ON_CHANGE_DESCRIPTION,
					onShow: _ON_SHOW_DESCRIPTION,
					onHide: _ON_HIDE_DESCRIPTION						  	
};

COMPLETE_CLIENT_SIDE_FIELD_EVENTS = dojo.delegate(BASE_CLIENT_SIDE_FIELD_EVENTS);
COMPLETE_CLIENT_SIDE_FIELD_EVENTS.onValid = "This event is invoked when the field's value becomes valid after it was invalid";
COMPLETE_CLIENT_SIDE_FIELD_EVENTS.onInvalid ="This event is invoked when the field's value becomes invalid after it was valid";

BASE_FIELD_EVENTS={
			categories:[{
				name:"CLIENT_SIDE",
				events:BASE_CLIENT_SIDE_FIELD_EVENTS
			}]
};

FIELD_EVENTS  = {
			categories:[{
				name:"CLIENT_SIDE",
				events:COMPLETE_CLIENT_SIDE_FIELD_EVENTS
			}]
};

FORM_CLIENT_SIDE_EVENTS_CATEGORY = {
			name:"CLIENT_SIDE",
			events:
			{
				onCreate: "This event is invoked after the form's widgets are created, and before any data is loaded onto the form", 
				onLoad: "This event is invoked after the form's data is loaded onto the form, and before it is presented",
				onShow: 'This event is invoked after the form is presented',
				onHide: 'This event is invoked after the form becomes hidden',
				beforeSave: 'This event is invoked before the form is saved',
				afterSave: 'This event is invoked after the form is saved',
				onDestruct: "This event is invoked after the form's data is unloaded, after it became hidden"				
			}
};

TOP_LEVEL_FORM_SERVER_SIDE_EVENTS_CATEGORY = {
			name:"SERVER_SIDE",
			events:
			{
				requestBegin:"This event is invoked when the request begins to be processed",
				secure:"This event is invoked after the security check is completed",
				GET: "This event is invoked upon processing a GET request",
				PUT: "This event is invoked upon processing a PUT request",
				POST: "This event is invoked upon processing a POST request",
				DELETE: "This event is invoked upon processing a DELETE request",
				log: "This event is invoked upon writing to the log",
				requestEnd:"This event is invoked when the request processing ends"
			}
};

BASE_FORM_EVENTS={ categories:[FORM_CLIENT_SIDE_EVENTS_CATEGORY]};
FORM_EVENTS = { categories:[FORM_CLIENT_SIDE_EVENTS_CATEGORY, TOP_LEVEL_FORM_SERVER_SIDE_EVENTS_CATEGORY]};




